using UnityEngine;
using System.Collections;

public class CellBehaviour : MonoBehaviour {

	private GlobalBehaviour globalobj;

	// Use this for initialization
	void Start () {
		GameObject go = GameObject.Find("Global");
		globalobj = go.GetComponent<GlobalBehaviour>();
	}
	
	// Update is called once per frame
	void Update () {
		int neiborNum = 0;
		if (checkCell(transform.position, Vector3.right)) neiborNum++;
		if (checkCell(transform.position, -Vector3.right)) neiborNum++;
		if (checkCell(transform.position, Vector3.forward)) neiborNum++;
		if (checkCell(transform.position, -Vector3.forward)) neiborNum++;
		if (checkCell(transform.position, Vector3.right+Vector3.forward)) neiborNum++;
		if (checkCell(transform.position, -Vector3.right+Vector3.forward)) neiborNum++;
		if (checkCell(transform.position, Vector3.right-Vector3.forward)) neiborNum++;
		if (checkCell(transform.position, -Vector3.right-Vector3.forward)) neiborNum++;
		if(neiborNum < 2 || neiborNum > 3) globalobj.deadlist.Add(gameObject); //死にリストに突っ込む
	}
	
	bool checkCell(Vector3 org, Vector3 dir) {
		if (Physics.Raycast(org, dir, 1)) return true;
		else {
			Vector3 spos = org + dir;
			if(globalobj.spawnlist.Contains(spos)) return false; // 誕生済みなので無駄だからここで止める
			
			// 透明オブジェクトは作りたくなかったので、生きてるセルに誕生の可能性を代わりに探らせる
			int neiborNum = 0;
			if (spawnCheckCell(spos, Vector3.right, dir)) neiborNum++;
			if (spawnCheckCell(spos, -Vector3.right, dir)) neiborNum++;
			if (spawnCheckCell(spos, Vector3.forward, dir)) neiborNum++;
			if (spawnCheckCell(spos, -Vector3.forward, dir)) neiborNum++;
			if (spawnCheckCell(spos, Vector3.right+Vector3.forward, dir)) neiborNum++;
			if ( neiborNum < 5 ) {
				if (spawnCheckCell(spos, -Vector3.right+Vector3.forward, dir)) neiborNum++;
				if ( neiborNum < 5 ) {
					if (spawnCheckCell(spos, Vector3.right-Vector3.forward, dir)) neiborNum++;
					if ( neiborNum < 5 ) {
						if (spawnCheckCell(spos, -Vector3.right-Vector3.forward, dir)) neiborNum++;
					}
				}
			}
			if(neiborNum == 3) globalobj.spawnlist[spos] = null; //誕生位置登録
			return false;
		}
	}
	
	bool spawnCheckCell(Vector3 org, Vector3 dir, Vector3 parentDir) {
		if(parentDir == -dir) return true;
		else return Physics.Raycast(org, dir, 1);
	}

}
